"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// tslint:disable max-line-length
/**
 * @private
 * @internal
 */
exports.delegates = function (rs) { return ({
    /**
     * Creates a new delegate. Be aware that this will send your secrets over the network
     * @deprecated
     */
    enable: function (data, callback) {
        return rs({
            data: data,
            method: 'PUT',
            path: '/delegates',
        }, callback);
    },
    getList: function (query, callback) {
        if (query === void 0) { query = {}; }
        return rs({
            params: query,
            path: '/delegates',
        }, callback);
    },
    getByUsername: function (username, callback) {
        return this.getByKeyVal('username', username, callback);
    },
    getByPublicKey: function (publicKey, callback) {
        return this.getByKeyVal('publicKey', publicKey, callback);
    },
    getByKeyVal: function (key, value, callback) {
        var query = {};
        query[key] = value;
        return rs({
            params: query,
            path: '/delegates/get',
        }, callback);
    },
    getVoters: function (publicKey, callback) {
        return rs({
            params: { publicKey: publicKey },
            path: '/delegates/voters',
        }, callback);
    },
    toggleForging: function (obj, callback) {
        return rs({
            data: {
                secret: obj.secret,
            },
            method: 'POST',
            path: "/delegates/forging/" + (obj.enable ? 'enable' : 'disable'),
        }, callback);
    },
    getForgedByAccount: function (data, callback) {
        return rs({
            params: typeof (data) === 'string' ? {
                generatorPublicKey: data,
            } : data,
            path: '/delegates/forging/getForgedByAccount',
        }, callback);
    },
    getForgingStatus: function (publicKey, callback) {
        if (typeof (publicKey) === 'function') {
            callback = publicKey;
            publicKey = undefined;
        }
        return rs({
            params: { publicKey: publicKey },
            path: '/delegates/forging/status',
        }, callback);
    },
    getNextForgers: function (limit, callback) {
        return rs({
            params: { limit: limit },
            path: '/delegates/getNextForgers',
        }, callback);
    },
    search: function (query, callback) {
        return rs({
            params: query,
            path: '/delegates/search',
        }, callback);
    },
}); };
