"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @private
 * @internal
 */
exports.transactions = function (rs) { return ({
    get: function (id, callback) {
        return rs({
            params: { id: id },
            path: '/transactions/get',
        }, callback);
    },
    count: function (callback) {
        return rs({
            path: '/transactions/count',
        }, callback);
    },
    getList: function (query, callback) {
        if (query === void 0) { query = {}; }
        return rs({
            params: __assign({}, query),
            path: '/transactions',
        }, callback);
    },
    getUnconfirmedTransactions: function (callback) {
        return rs({
            path: '/transactions/unconfirmed',
        }, callback);
    },
    getUnconfirmedTransaction: function (id, callback) {
        return rs({
            params: { id: id },
            path: '/transactions/unconfirmed/get',
        }, callback);
    },
    put: function (tx, callback) {
        if (Array.isArray(tx)) {
            return rs({
                data: { transactions: tx },
                method: 'PUT',
                path: '/transactions',
            }, callback);
        }
        return rs({
            data: { transaction: tx },
            method: 'PUT',
            path: '/transactions',
        }, callback);
    },
}); };
