"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.transport = function (rs) {
    return function (headers) { return ({
        getHeaders: function () {
            return headers;
        },
        getHeight: function (cback) {
            return rs({
                headers: headers,
                noApiPrefix: true,
                path: '/peer/height',
            }, cback);
        },
        listPeers: function (cback) {
            return rs({
                headers: headers,
                noApiPrefix: true,
                path: '/peer/list',
            }, cback);
        },
        ping: function (cback) {
            return rs({
                headers: headers,
                noApiPrefix: true,
                path: '/peer/ping',
            }, cback);
        },
        postTransaction: function (transaction, cback) {
            return rs({
                data: { transaction: transaction },
                headers: headers,
                method: 'POST',
                noApiPrefix: true,
                path: '/peer/transactions',
            }, cback);
        },
        postTransactions: function (transactions, cback) {
            return rs({
                data: { transactions: transactions },
                headers: headers,
                method: 'POST',
                noApiPrefix: true,
                path: '/peer/transactions',
            }, cback);
        },
        postSignature: function (signature, cback) {
            return rs({
                data: (function () {
                    if (Array.isArray(signature)) {
                        return { signatures: signature };
                    }
                    else {
                        return { signature: signature };
                    }
                })(),
                headers: headers,
                method: 'POST',
                noApiPrefix: true,
                path: '/peer/signatures',
            }, cback);
        },
    }); };
};
