"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
var axios_1 = require("axios");
var _1 = require("./apis/");
var internal_utils_1 = require("./internal_utils");
__export(require("./types/beans"));
exports.rise = (function () {
    var toRet = {
        errorAsResponse: true,
        nodeAddress: 'https://wallet.rise.vision',
        newWrapper: function (nodeAddress, opts) {
            if (opts === void 0) { opts = { timeout: 4000 }; }
            var req = internal_utils_1.requester(axios_1.default, nodeAddress, __assign({ errorAsResponse: true }, opts));
            return internal_utils_1.addTransportBuilder({
                accounts: _1.accounts(req),
                blocks: _1.blocks(req),
                delegates: _1.delegates(req),
                loader: _1.loader(req),
                multiSignatures: _1.multiSignatures(req),
                peers: _1.peers(req),
                rawRequest: req,
                signatures: _1.signatures(req),
                transactions: _1.transactions(req),
                transport: _1.transport(req),
            }, req);
        },
        timeout: 4000,
    };
    function rproxy(obj, cback) {
        return internal_utils_1.requester(axios_1.default, toRet.nodeAddress, { timeout: toRet.timeout, errorAsResponse: toRet.errorAsResponse }).apply(null, arguments);
    }
    toRet.accounts = _1.accounts(rproxy);
    toRet.loader = _1.loader(rproxy);
    toRet.transactions = _1.transactions(rproxy);
    toRet.peers = _1.peers(rproxy);
    toRet.blocks = _1.blocks(rproxy);
    toRet.signatures = _1.signatures(rproxy);
    toRet.delegates = _1.delegates(rproxy);
    toRet.multiSignatures = _1.multiSignatures(rproxy);
    toRet.transport = _1.transport(rproxy);
    toRet.rawRequest = rproxy;
    return internal_utils_1.addTransportBuilder(toRet, rproxy);
})();
