import { AxiosStatic } from 'axios';
import { BlocksAPI } from './types/apis/BlocksAPI';
import { PeersAPI } from './types/apis/PeersAPI';
import { TransportApi } from './types/apis/TransportAPI';
import { BaseApiResponse, cback as cbackType, rs as rsType } from './types/base';
export declare const requester: (axios: AxiosStatic, nodeAddress: any, opts: {
    timeout: number;
    errorAsResponse: boolean;
}) => <R>(obj: {
    noApiPrefix?: boolean;
    headers?: any;
    params?: any;
    path: string;
    method?: string;
    data?: any;
}, cback: cbackType<R>) => Promise<R & BaseApiResponse>;
/**
 * Augments the object adding a new buildTransport function
 */
export declare function addTransportBuilder<T extends {
    blocks: BlocksAPI;
    peers: PeersAPI;
}>(obj: T, rs: rsType): T & {
    buildTransport: (flushCache?: boolean) => Promise<TransportApi>;
};
