"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var transport_1 = require("./apis/transport");
exports.requester = function (axios, nodeAddress, opts) { return function (obj, cback) {
    return axios(__assign({ json: true, timeout: opts.timeout, url: "" + nodeAddress + (obj.noApiPrefix ? '' : '/api') + obj.path }, obj))
        .catch(function (err) {
        if (err.response && err.response.data && !err.response.data.success) {
            if (opts.errorAsResponse) {
                return err.response;
            }
            return Promise.reject(new Error(err.response.data.error || err.response.data.message));
        }
        return Promise.reject(err);
    })
        .then(function (resp) {
        if (resp.data.success === false) {
            if (opts.errorAsResponse) {
                return resp.data;
            }
            return Promise.reject(new Error(resp.data.error || resp.data.message));
        }
        return resp.data;
    })
        .then(function (a) {
        if (typeof (cback) !== 'undefined') {
            cback(null, a);
        }
        return a;
    })
        .catch(function (err) {
        if (typeof (cback) !== 'undefined') {
            cback(err);
        }
        return Promise.reject(err);
    });
}; };
/**
 * Augments the object adding a new buildTransport function
 */
function addTransportBuilder(obj, rs) {
    var transportCache = null;
    // tslint:disable-next-line no-string-literal
    obj['buildTransport'] = function (flushCache) {
        if (flushCache === void 0) { flushCache = false; }
        if (flushCache || transportCache === null) {
            return Promise.all([
                obj.peers.version(),
                obj.blocks.getStatus(),
            ])
                .then(function (resp) { return ({
                nethash: resp[1].nethash,
                port: 1000,
                version: resp[0].version,
            }); })
                .then(function (h) {
                transportCache = transport_1.transport(rs)(h);
                return transportCache;
            });
        }
        return Promise.resolve(transportCache);
    };
    return obj; // TS bug 10727 on spread operators i need to do this.
}
exports.addTransportBuilder = addTransportBuilder;
